/*
 * Buxton
 *
 * Copyright (C) 2019 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "buxton_error.h"

#ifndef EXPORT
#  define EXPORT __attribute__((visibility("default")))
#endif

static int buxton_errno;

EXPORT char* buxton_err_get_str(int err)
{
	switch (err) {
	case BUXTON_ERROR_INVALID_PARAMETER:
		return "BUXTON_ERROR_INVALID_PARAMETER";
	case BUXTON_ERROR_OUT_OF_MEMORY:
		return "BUXTON_ERROR_OUT_OF_MEMORY";
	case BUXTON_ERROR_IO_ERROR:
		return "BUXTON_ERROR_IO_ERROR";
	case BUXTON_ERROR_PERMISSION_DENIED:
		return "BUXTON_ERROR_PERMISSION_DENIED";
	case BUXTON_ERROR_INVALID_OPERATION:
		return "BUXTON_ERROR_INVALID_OPERATION";
	case BUXTON_ERROR_NOT_EXIST:
		return "BUXTON_ERROR_NOT_EXIST";
	case BUXTON_ERROR_EXIST:
		return "BUXTON_ERROR_EXIST";
	case BUXTON_ERROR_TIME_OUT:
		return "BUXTON_ERROR_TIME_OUT";
	case BUXTON_ERROR_DATA_TOO_LONG:
		return "BUXTON_ERROR_DATA_TOO_LONG";
	default:
		return "Unknow error";
	}
}

void buxton_err_set_errno(int err)
{
	buxton_errno = -(err);
	errno = -(err);
}

EXPORT int buxton_err_get_errno(void)
{
	return buxton_errno;
}

